(* We've seen in lecture and on previous assignments how to extend our
   `expr` "language" with more integer operations. But what about
   other types? In this file, we'll add booleans to our language. *)

(* Begin by copying your `expr` datatype from the previous file. *)

(* Problem 1: Modify `expr` to add these new programming constructs:
     - boolean constants (true and false)
     - boolean and
     - if-then-else expressions
     - the less-than-or-equal-to operation
*)

(* Now we'd like to extend our evaluator to the new language.

   Start by copying over your `eval` function from the previous
   language. *)

(* Problem 2: Try to extend `eval` to the new language, starting first
   with the boolean constants. What problem do you run into with its
   return type? *)

(* Problem 3: Introduce a new datatype, called `value` which will
   represent the possible return values for `eval`. Think carefully
   about how many constructors the datatype will need.

   Hint: How many "types" of values are there in our language so far? *)

(* Problem 4: Finish the new definition of `eval`.

   First change `eval` to return a `value` instead. In each branch of
   `eval`, use a constructor of the `value` type to "package up" your
   answer.

   In the previous language, we "knew" what kind of value recursive
   calls to `eval` would return (it would always be an int). Now, we
   don't necessarily know, since it could be built with any of the
   constructors for the `value` type. However, each of the operations
   in our language expects values of a certain type, so we will need to
   check that the values were built using the correct constructor.

   Write helper functions, one per constructor of `value`, that "cast"
   a value to that type. For example, one of your constructors to
   `value` should be for integer values, so one of your helper
   functions should be of type `value -> int`. In these cast
   functions, throw an exception if the value was not built with the
   correct constructor. (You can introduce a new exception or just use
   `Fail` with an appropriate message.)

   Now complete the definition of `eval`. You should implement the
   intuitive meaning of each new program construct. For example, the
   "and" operation on booleans should recursively evaluate its
   subexpressions, use the "casting" helper functions convert the
   results to booleans and then return a boolean `value` representing
   their "and".

   For less-than-or-equal-to, assume that only integers are compared.

   For if-then-else expressions, do not assume anything in particular
   about the types of the "then" and "else" branches.
*)

(* Problem 5: Write enough tests that you use each new programming
   construct at least once, and record them here as bindings (to
   whatever variable names you want).

   Also, find an expression that causes your evaluator to throw an
   exception, and bind it to the name `bad_expr`. Contemplate how one
   might "rule out" expressions like this one. *)
