(* As you probably guessed, we can rule out "bad expressions" (those
   that would cause the evaluator to throw exceptions) by introducing
   a typechecker. *)

(* Problem 1: Explain why your `bad_expr` at the bottom of the
   previous file would not pass a typechecker. (Just use your
   intuitive understanding of how typecheckers (eg, SML's) work, no
   need to get very technical.) *)

(* Start by copying over all your code from the previous file. *)

(* Now it's time to implement a typechecker for expressions. *)

(* Problem 2: Introduce a new datatype called `ty`, to represent the
   possible types for expressions. (We can't call it `type` because
   that's a keyword in SML. But it will also help us not get confused
   between SML types and the types of our little expression language.)

   `ty` should have one constructor for each possible type in the
   expression language. The constructors should take no additional
   data; they only serve to "name" types. *)

(* Problem 3: Implement a typechecker as a function `typecheck` of
   type `expr -> ty`.

   Just like the evaluator, the typechecker will need to consider each
   kind of expression separately, and implement the typechecking rule
   for that kind of expression. Recall a few relevant examples from
   when we learned the typechecking rules for SML:
     - integer constants have type int
     - to typecheck `e1 + e2`, typecheck e1 and e2 and ensure that
       they are ints; then the result is also int.
     - to typecheck `if e1 then e2 else e3`, first typecheck e1 and
       ensure that it is a bool; then typecheck e2 and e3 and ensure
       that they have the same type as each other.

   You will need to implement rules like these for each kind of
   expression in the language.

   Your typechecker should raise an exception if the given expression
   does not typecheck. For example, adding a boolean to an int should
   cause it to raise an exception. (You can introduce a new exception
   or just use `Fail` with an appropriate message.)

   There are several ways to implement the "checks" of the
   typechecker. You could directly use SML's if-then-else or pattern
   matching to see whether the type is as expected, throwing an
   exception if not. Or you could use helper functions (somewhat
   analogous to the "casting" functions used in the evaluator) that
   "assert" that the type is a particular one, and throw an exception
   otherwise. It's up to you which strategy you chose.
 *)

(* Problem 4: Write enough tests that you typecheck every kind of
   expression at least once. Bind your tests to variable names of your
   choosing here.

   Make sure your typechecker throws an exception when given your
   `bad_expr` from the previous file.

   Make sure your tyechecker still throws an exception even if
   `bad_expr` is nested inside some larger program.

   Convince yourself that no expression that passes the typechecker
   can ever cause the evaluator to throw an exception. *)
